package nc.bs.jitu.itf;

package ..deTemp.1737037255085;

import java.util.ArrayList;
import java.util.List;
import nc.bs.arap.util.ArapFlowUtil;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.bs.jitu.itf.TransUtil;
import nc.bs.pf.pub.PfDataCache;
import nc.bs.pub.pa.PreAlertObject;
import nc.bs.pub.taskcenter.BgWorkingContext;
import nc.bs.pub.taskcenter.IBackgroundWorkPlugin;
import nc.itf.jitu.ISyncData;
import nc.itf.uap.IUAPQueryBS;
import nc.itf.uap.pf.IPFConfig;
import nc.jdbc.framework.SQLParameter;
import nc.jdbc.framework.processor.BeanProcessor;
import nc.jdbc.framework.processor.ResultSetProcessor;
import nc.tools.LoggerTools;
import nc.util.mmf.busi.service.OrgUnitPubService;
import nc.vo.arap.basebill.BaseItemVO;
import nc.vo.arap.pay.AggPayBillVO;
import nc.vo.arap.pay.PayBillItemVO;
import nc.vo.arap.pay.PayBillVO;
import nc.vo.arap.pub.BillEnumCollection;
import nc.vo.bd.accessor.IBDData;
import nc.vo.bd.accessor.bankaccsub.BankaccsubBDDataVO;
import nc.vo.jcom.lang.StringUtil;
import nc.vo.jitu.itf.ItfFkdVO;
import nc.vo.jitu.pub.SyncLogVO;
import nc.vo.org.DeptVO;
import nc.vo.pub.AggregatedValueObject;
import nc.vo.pub.BusinessException;
import nc.vo.pub.CircularlyAccessibleValueObject;
import nc.vo.pub.SuperVO;
import nc.vo.pub.billtype.BilltypeVO;
import nc.vo.pub.lang.UFDateTime;
import nc.vo.pub.lang.UFDouble;
import nc.vo.pubapp.AppContext;

public class FkdBgPlugin extends TransUtil<ItfFkdVO> implements IBackgroundWorkPlugin {
  public PreAlertObject executeTask(BgWorkingContext bgwc) throws BusinessException {
    String pkOrg = (String)bgwc.getKeyMap().get("pkOrg");
    return executeTask(bgwc, "itf_fkd", pkOrg);
  }
  
  protected void transBill(List<ItfFkdVO> lst) throws BusinessException {
    PayBillVO hvo = doHeadProcess(lst.get(0));
    UFDateTime nctime = AppContext.getInstance().getServerTime();
    ISyncData bo = (ISyncData)NCLocator.getInstance().lookup(ISyncData.class);
    List<SyncLogVO> logLst = new ArrayList<>();
    if (hvo == null) {
      this.numerror += lst.size();
      String str = ((ItfFkdVO)lst.get(0)).getErrormes();
      for (ItfFkdVO vo : lst) {
        vo.setNcbillno(null);
        vo.setNctime(nctime);
        vo.setErrormes(str);
        vo.setDatastatus(Integer.valueOf(3));
        logLst.add(vo.toLog());
      } 
      return;
    } 
    List<PayBillItemVO> itemlst = new ArrayList<>();
    boolean haserrorItem = false;
    for (ItfFkdVO vo : lst) {
      PayBillItemVO item = doBodyProcess(vo, hvo);
      if (item != null) {
        vo.setDatastatus(Integer.valueOf(2));
        vo.setNctime(nctime);
        itemlst.add(item);
        continue;
      } 
      haserrorItem = true;
      logLst.add(vo.toLog());
      break;
    } 
    if (haserrorItem) {
      this.numerror += lst.size();
      for (ItfFkdVO vo : lst) {
        vo.setNcbillno(null);
        vo.setNctime(nctime);
        if (vo.getDatastatus().intValue() == 2 || vo.getDatastatus().intValue() == 0) {
          vo.setErrormes("同批次其他行错误");
          vo.setDatastatus(Integer.valueOf(3));
          logLst.add(vo.toLog());
        } 
      } 
      saveLogs(logLst);
      return;
    } 
    String errmsg = null;
    String ncbillno = null;
    AggPayBillVO bill = new AggPayBillVO();
    bill.setParentVO((CircularlyAccessibleValueObject)hvo);
    bill.setChildrenVO((CircularlyAccessibleValueObject[])itemlst.toArray((Object[])new PayBillItemVO[0]));
    String actionCode = ArapFlowUtil.getCommitActionCode(hvo.getPk_org(), "F3");
    String actionCode2 = ArapFlowUtil.getCommitActionCodeBySSC(hvo.getPk_org(), "F3");
    String actionCode3 = ArapFlowUtil.getApproveActionCode(hvo.getPk_org(), "F3");
    ItfFkdVO[] itfvos = lst.<ItfFkdVO>toArray(new ItfFkdVO[0]);
    try {
      bill = (AggPayBillVO)bo.billSave_RequiresNew(actionCode, "F3", (AggregatedValueObject)bill, (SuperVO[])itfvos);
      ncbillno = (String)bill.getParentVO().getAttributeValue("billno");
      bill = (AggPayBillVO)bo.billSave_RequiresNew(actionCode2, "F3", (AggregatedValueObject)bill, (SuperVO[])itfvos);
      ncbillno = (String)bill.getParentVO().getAttributeValue("billno");
      long bizDateTime = InvocationInfoProxy.getInstance().getBizDateTime();
      ncbillno = (String)bill.getParentVO().getAttributeValue("billno");
      bill.getHeadVO().setApprovedate(new UFDateTime(bizDateTime));
      bill.getHeadVO().setApprover(bill.getHeadVO().getBillmaker());
      bill = (AggPayBillVO)bo.billSave_RequiresNew(actionCode3, "F3", (AggregatedValueObject)bill, (SuperVO[])itfvos);
      ncbillno = (String)bill.getParentVO().getAttributeValue("billno");
      LoggerTools.error("付款单审核成功，billno=" + ncbillno);
      ncbillno = (String)bill.getParentVO().getAttributeValue("billno");
    } catch (Exception e) {
      errmsg = e.getMessage();
    } 
    byte b;
    int i;
    ItfFkdVO[] arrayOfItfFkdVO1;
    for (i = (arrayOfItfFkdVO1 = itfvos).length, b = 0; b < i; ) {
      ItfFkdVO vo = arrayOfItfFkdVO1[b];
      vo.setNctime(nctime);
      vo.setNcbillno(ncbillno);
      if (vo.getDatastatus().intValue() == 2) {
        if (ncbillno == null) {
          this.numerror++;
          vo.setErrormes(errmsg);
          vo.setDatastatus(Integer.valueOf(3));
        } else {
          this.numok++;
          if (errmsg != null && !"".equals(errmsg))
            vo.setDatastatus(Integer.valueOf(3)); 
          vo.setErrormes(errmsg);
          vo.setNcbillno(ncbillno);
        } 
      } else {
        this.numerror++;
      } 
      logLst.add(vo.toLog());
      b++;
    } 
    saveLogs(logLst);
  }
  
  public PayBillVO doHeadProcess(ItfFkdVO ysdvo) throws BusinessException {
    String PK_ORG = ysdvo.getPk_org();
    String customer = ysdvo.getCustsup();
    String VTRANTYPECODE = ysdvo.getPk_tradetypeid();
    if (StringUtil.isEmpty(PK_ORG) || StringUtil.isEmpty(customer) || ysdvo.getBilldate() == null || StringUtil.isEmpty(VTRANTYPECODE)) {
      ysdvo.setDatastatus(Integer.valueOf(3));
      ysdvo.setErrormes("财务组织,单据日期,客户,应收类型不能为空");
      this.numerror++;
      return null;
    } 
    IBDData bdData = this.orgAcc.getDocByCode("GLOBLE00000000000000", PK_ORG);
    if (bdData == null) {
      ysdvo.setDatastatus(Integer.valueOf(3));
      ysdvo.setErrormes("财务组织无法翻译" + PK_ORG);
      this.numerror++;
      return null;
    } 
    PayBillVO hvo = new PayBillVO();
    hvo.setPk_group(bdData.getPk_group());
    hvo.setPk_org(bdData.getPk());
    String pk_org_v = OrgUnitPubService.getNewVIDByOrgID(hvo.getPk_org());
    hvo.setPk_org_v(pk_org_v);
    hvo.setPk_fiorg(bdData.getPk());
    hvo.setPk_fiorg_v(pk_org_v);
    hvo.setSett_org(bdData.getPk());
    hvo.setSett_org_v(pk_org_v);
    hvo.setSendcountryid("0001Z010000000079UJJ");
    hvo.setPk_currtype("1002Z0100000000001K1");
    hvo.setBillstatus(Integer.valueOf(-1));
    hvo.setBillmaker(this.pk_user);
    hvo.setCreator(this.pk_user);
    hvo.setObjtype(BillEnumCollection.ObjType.SUPPLIER.VALUE);
    IBDData custData = this.custSuppAcc.getDocByCode(hvo.getPk_org(), customer);
    if (custData == null) {
      ysdvo.setDatastatus(Integer.valueOf(3));
      ysdvo.setErrormes("供应商无法翻译" + customer);
      this.numerror++;
      return null;
    } 
    hvo.setSupplier(custData.getPk());
    if (!StringUtil.isEmpty(ysdvo.getPayaccount())) {
      BankaccsubBDDataVO bdvo = this.bankAccSubAcc.getDocByAccnum(ysdvo.getPayaccount(), hvo.getPk_currtype());
      if (bdvo == null) {
        ysdvo.setDatastatus(Integer.valueOf(3));
        ysdvo.setErrormes("无法翻译付款银行账户" + ysdvo.getPayaccount());
        this.numerror++;
        return null;
      } 
      hvo.setPayaccount(bdvo.getPk());
    } 
    if (!StringUtil.isEmpty(ysdvo.getRecaccount())) {
      BankaccsubBDDataVO bdvo = this.bankAccSubAcc.getDocByAccnum(ysdvo.getRecaccount(), hvo.getPk_currtype());
      if (bdvo == null) {
        ysdvo.setDatastatus(Integer.valueOf(3));
        ysdvo.setErrormes("无法翻译收款银行账户" + ysdvo.getRecaccount());
        this.numerror++;
        return null;
      } 
      hvo.setRecaccount(bdvo.getPk());
    } 
    if (!StringUtil.isEmpty(ysdvo.getCashaccount())) {
      IBDData bdvo = this.cashAccount_VAcc.getDocByCode(hvo.getPk_org(), ysdvo.getCashaccount());
      if (bdvo == null) {
        ysdvo.setDatastatus(Integer.valueOf(3));
        ysdvo.setErrormes("无法翻译现金账户" + ysdvo.getCashaccount());
        this.numerror++;
        return null;
      } 
      hvo.setCashaccount(bdvo.getPk());
    } 
    if (!StringUtil.isEmpty(ysdvo.getPk_balatype())) {
      IBDData bdvo = this.balaAcc.getDocByCode(hvo.getPk_org(), ysdvo.getPk_balatype());
      if (bdvo == null) {
        ysdvo.setDatastatus(Integer.valueOf(3));
        ysdvo.setErrormes("无法翻译结算方式" + ysdvo.getPk_balatype());
        this.numerror++;
        return null;
      } 
      hvo.setPk_balatype(bdvo.getPk());
    } 
    String pk_dept = ysdvo.getPk_dept();
    String sqldept = "";
    SQLParameter sp = new SQLParameter();
    IUAPQueryBS bs = (IUAPQueryBS)NCLocator.getInstance().lookup(IUAPQueryBS.class);
    if (!"".equals(pk_dept) && pk_dept != null) {
      sqldept = "select * from org_dept where code=? and pk_org=? and dr=0";
      sp.addParam(pk_dept);
      sp.addParam(hvo.getPk_org());
      DeptVO deptvo = (DeptVO)bs.executeQuery(sqldept, sp, (ResultSetProcessor)new BeanProcessor(DeptVO.class));
      if (deptvo != null) {
        hvo.setPk_deptid(deptvo.getPk_dept());
        hvo.setPk_deptid_v(deptvo.getPk_vid());
      } else {
        ysdvo.setDatastatus(Integer.valueOf(3));
        ysdvo.setErrormes("鍏徃涓?" + PK_ORG + "涓嬬殑閮ㄩ棬" + pk_dept + "鎵句笉鍒?");
        this.numerror++;
        return null;
      } 
    } 
    hvo.setBilldate(ysdvo.getBilldate());
    if (ysdvo.getBusidate() == null) {
      hvo.setBusidate(ysdvo.getBilldate());
    } else {
      hvo.setBusidate(ysdvo.getBusidate());
    } 
    hvo.setSrc_syscode(BillEnumCollection.FromSystem.AP.VALUE);
    hvo.setSyscode(BillEnumCollection.FromSystem.AP.VALUE);
    hvo.setAttributeValue("billclass", "fk");
    hvo.setApprovestatus(BillEnumCollection.ApproveStatus.NOSTATE.VALUE);
    hvo.setPk_billtype("F3");
    hvo.setPk_tradetype(VTRANTYPECODE);
    BilltypeVO billtypevo = PfDataCache.getBillType(VTRANTYPECODE);
    if (billtypevo == null) {
      ysdvo.setDatastatus(Integer.valueOf(3));
      ysdvo.setErrormes("单据类型无法翻译" + VTRANTYPECODE);
      this.numerror++;
      return null;
    } 
    hvo.setPk_tradetypeid(billtypevo.getPk_billtypeid());
    IPFConfig ipf = (IPFConfig)NCLocator.getInstance().lookup(IPFConfig.class);
    String pk_busitype = ipf.retBusitypeCanStart(hvo.getPk_billtype(), hvo.getPk_tradetype(), hvo.getPk_org(), hvo.getCreator());
    hvo.setPk_busitype(pk_busitype);
    hvo.setDef10(ysdvo.getJmsgroupid());
    return hvo;
  }
  
  public PayBillItemVO doBodyProcess(ItfFkdVO ysdvo, PayBillVO hvo) throws BusinessException {
    if (ysdvo.getMoney() == null) {
      ysdvo.setDatastatus(Integer.valueOf(3));
      ysdvo.setErrormes("金额 不能为空");
      this.numerror++;
      return null;
    } 
    PayBillItemVO item = new PayBillItemVO();
    item.setPk_group(hvo.getPk_group());
    item.setMoney_de(ysdvo.getMoney());
    item.setLocal_money_de(ysdvo.getMoney());
    item.setNotax_de(ysdvo.getMoney());
    item.setLocal_notax_de(ysdvo.getMoney());
    item.setLocal_tax_de(UFDouble.ZERO_DBL);
    String subjname = "";
    if (!StringUtil.isEmpty(ysdvo.getPk_subjcode())) {
      IBDData bddata = this.ioAcc.getDocByCode(hvo.getPk_org(), ysdvo.getPk_subjcode());
      if (bddata == null) {
        ysdvo.setDatastatus(Integer.valueOf(3));
        ysdvo.setErrormes("收支项目无法翻译" + ysdvo.getPk_subjcode());
        this.numerror++;
        return null;
      } 
      item.setPk_subjcode(bddata.getPk());
      subjname = bddata.getName().getText();
    } 
    if (!StringUtil.isEmpty(ysdvo.getMaterial())) {
      IBDData bddata = this.materialAcc.getDocByCode(hvo.getPk_org(), ysdvo.getMaterial());
      if (bddata == null) {
        ysdvo.setDatastatus(Integer.valueOf(3));
        ysdvo.setErrormes("物料无法翻译" + ysdvo.getMaterial());
        this.numerror++;
        return null;
      } 
      item.setMaterial(bddata.getPk());
      bddata = this.material_VAcc.getDocByCode(hvo.getPk_org(), ysdvo.getMaterial());
      if (bddata == null) {
        ysdvo.setDatastatus(Integer.valueOf(3));
        ysdvo.setErrormes("物料无法翻译");
        this.numerror++;
        return null;
      } 
      item.setMaterial_src(bddata.getPk());
    } 
    if (!StringUtil.isEmpty(ysdvo.getProject())) {
      IBDData bdvo = this.projAcc.getDocByCode(hvo.getPk_org(), ysdvo.getProject());
      if (bdvo == null) {
        ysdvo.setDatastatus(Integer.valueOf(3));
        ysdvo.setErrormes("无法翻译项目" + ysdvo.getProject());
        return null;
      } 
      item.setProject(bdvo.getPk());
    } 
    SuperVO tmpvo = tranDef((SuperVO)item, (SuperVO)ysdvo);
    if (tmpvo == null)
      return null; 
    setRecPayType((BaseItemVO)item, ysdvo.getPk_tradetypeid());
    StringBuilder sb = new StringBuilder();
    if (!StringUtil.isEmpty(ysdvo.getDef6()))
      sb.append(ysdvo.getDef6()); 
    sb.append("/付/");
    sb.append(subjname);
    item.setScomment(StringUtil.isEmpty(ysdvo.getComment()) ? sb.toString() : ysdvo.getComment());
    item.setPk_currtype(hvo.getPk_currtype());
    item.setObjtype(hvo.getObjtype());
    item.setSupplier(hvo.getSupplier());
    item.setOrdercubasdoc(hvo.getSupplier());
    item.setPk_deptid(hvo.getPk_deptid());
    item.setPk_deptid_v(hvo.getPk_deptid_v());
    item.setPk_billtype(hvo.getPk_billtype());
    item.setPk_fiorg(hvo.getPk_fiorg());
    item.setPk_fiorg_v(hvo.getPk_fiorg_v());
    item.setPk_org(hvo.getPk_org());
    item.setPk_org_v(hvo.getPk_org_v());
    item.setSett_org(hvo.getSett_org());
    item.setSett_org_v(hvo.getSett_org_v());
    item.setPk_tradetype(hvo.getPk_tradetype());
    item.setPk_tradetypeid(hvo.getPk_tradetypeid());
    item.setPayaccount(hvo.getPayaccount());
    item.setRecaccount(hvo.getRecaccount());
    item.setCashaccount(hvo.getCashaccount());
    item.setPk_balatype(hvo.getPk_balatype());
    item.setRate(UFDouble.ONE_DBL);
    item.setGrouprate(UFDouble.ZERO_DBL);
    item.setGlobalrate(UFDouble.ZERO_DBL);
    item.setBusidate(ysdvo.getBusidate());
    item.setBilldate(hvo.getBilldate());
    return item;
  }
}
